
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Team_membershipsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const team_memberships = await db.team_memberships.create(
            {
                id: data.id || undefined,
        
        membership_role: data.membership_role
        ||
        null
            ,
            
        joined_at: data.joined_at
        ||
        null
            ,
            
        left_at: data.left_at
        ||
        null
            ,
            
        is_primary_team: data.is_primary_team
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await team_memberships.setTeam( data.team || null, {
            transaction,
        });
        
        await team_memberships.setUser( data.user || null, {
            transaction,
        });
        
        await team_memberships.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return team_memberships;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const team_membershipsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                membership_role: item.membership_role
            ||
            null
            ,
            
                joined_at: item.joined_at
            ||
            null
            ,
            
                left_at: item.left_at
            ||
            null
            ,
            
                is_primary_team: item.is_primary_team
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const team_memberships = await db.team_memberships.bulkCreate(team_membershipsData, { transaction });

        // For each item created, replace relation files
        

        return team_memberships;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const team_memberships = await db.team_memberships.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.membership_role !== undefined) updatePayload.membership_role = data.membership_role;
        
        
        if (data.joined_at !== undefined) updatePayload.joined_at = data.joined_at;
        
        
        if (data.left_at !== undefined) updatePayload.left_at = data.left_at;
        
        
        if (data.is_primary_team !== undefined) updatePayload.is_primary_team = data.is_primary_team;
        
        
        updatePayload.updatedById = currentUser.id;

        await team_memberships.update(updatePayload, {transaction});

        
        
        if (data.team !== undefined) {
            await team_memberships.setTeam(
              
              data.team,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await team_memberships.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await team_memberships.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return team_memberships;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const team_memberships = await db.team_memberships.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of team_memberships) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of team_memberships) {
                await record.destroy({transaction});
            }
        });


        return team_memberships;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const team_memberships = await db.team_memberships.findByPk(id, options);

        await team_memberships.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await team_memberships.destroy({
            transaction
        });

        return team_memberships;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const team_memberships = await db.team_memberships.findOne(
            { where },
            { transaction },
        );

        if (!team_memberships) {
            return team_memberships;
        }

        const output = team_memberships.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.team = await team_memberships.getTeam({
            transaction
        });
        
        
        output.user = await team_memberships.getUser({
            transaction
        });
        
        
        output.organizations = await team_memberships.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.teams,
        as: 'team',
        
        where: filter.team ? {
          [Op.or]: [
            { id: { [Op.in]: filter.team.split('|').map(term => Utils.uuid(term)) } },
            {
              team_name: {
                [Op.or]: filter.team.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.joined_atRange) {
                const [start, end] = filter.joined_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.left_atRange) {
                const [start, end] = filter.left_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    left_at: {
                    ...where.left_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    left_at: {
                    ...where.left_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.membership_role) {
                where = {
                    ...where,
                membership_role: filter.membership_role,
            };
            }
            
            if (filter.is_primary_team) {
                where = {
                    ...where,
                is_primary_team: filter.is_primary_team,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.team_memberships.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'team_memberships',
                        'membership_role',
                        query,
                    ),
                ],
            };
        }

        const records = await db.team_memberships.findAll({
            attributes: [ 'id', 'membership_role' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['membership_role', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.membership_role,
        }));
    }

    
};

